<template>
  <v-container fluid>
    <v-layout row wrap class="d-flex justify-space-around">
      <v-card
        outlined
        class="my-3 d-inline-block"
        v-for="article in articles"
        :key="article.title"
        @click="goToDetails(article.id)"
        max-width="360px"
      >
        <v-container class="py-0">
          <v-row>
            <v-img
              class="align-end overflow-hidden"
              max-height="360px"
              min-height="360px"
              :src="imgURL(article.imagePath)"
            >
              <v-card-title class="white--text display-1" style="text-stroke: 1.4px black;">
                <strong>{{ article.title }}</strong>
              </v-card-title>

              <v-card-subtitle class="title grey--text" style="text-stroke: 1px black">
                <strong>{{ article.date | moment('LL') }}</strong>
              </v-card-subtitle>
            </v-img>
          </v-row>
          <v-row>
            <v-card-text class="my-card-text">{{ article.description }}</v-card-text>
          </v-row>
        </v-container>
        <div class="d-flex align-end justify-end mr-5 indigo--text">
          <p>...</p>
        </div>
      </v-card>
    </v-layout>
  </v-container>
</template>

<script>
import Api from '@/mixins/api'
import imgURL from '@/utils/imgURL'
import config from '@/config'

// @group VIEWS
export default {
  mixins: [Api],
  computed: {
    articles() {
      /**
       * @vuese
       * Returns articles from VueX store
       */
      return this.$store.state.news
    },
  },
  methods: {
    /**
     * @vuese
     * Returns image URL from imgURL component
     * @arg Property logo from object sponsor in sponsors array
     */
    imgURL(path) {
      return imgURL(config.server.ip, path, config.server.port)
    },
    /**
     * @vuese
     * Redirects to details of news
     * @arg Article id from article object in articles array
     */
    goToDetails(id) {
      this.$router.push(`/news/${id}`)
    },
  },
  created() {
    /**
     * @vuese
     * Gets news every 60 seconds
     * @arg -
     */
    this.getNews()
    setInterval(this.getNews, 60000)
  },
}
</script>

<style scoped lang="scss">
.my-card-text {
  line-height: 1.5em;
  height: 5.5em;
  overflow: hidden;
  white-space: wrap;
  text-overflow: ellipsis;
  width: 100%;
}
/*.py-0::after {*/
/*  color: #0d47a1;*/
/*  content: '...';*/
/*}*/
.v-card-title {
  color: white;
  text-shadow: -1px -1px 0 #000, 1px -1px 0 #000, -1px 1px 0 #000, 1px 1px 0 #000;
}
</style>
